Package org.eclipse.birt.report.model.api

# Class ListingHandle

java.lang.Object
org.eclipse.birt.report.model.api.DesignElementHandle
org.eclipse.birt.report.model.api.ReportElementHandle
org.eclipse.birt.report.model.api.ReportItemHandleImpl
org.eclipse.birt.report.model.api.ReportItemHandle
org.eclipse.birt.report.model.api.ListingHandle

All Implemented Interfaces:
  `IReportItemMethodContext`, `org.eclipse.birt.report.model.elements.interfaces.IDesignElementModel`, `org.eclipse.birt.report.model.elements.interfaces.IInternalReportItemModel`, `org.eclipse.birt.report.model.elements.interfaces.IListingElementModel`, `org.eclipse.birt.report.model.elements.interfaces.IStyledElementModel`

Direct Known Subclasses:
  `ListHandle`, `TableHandle`

public abstract class ListingHandle extends ReportItemHandle implements org.eclipse.birt.report.model.elements.interfaces.IListingElementModel
Represents slots and common properties in the two list-oriented elements: table and list. A listing has on-start, on-row and on-finish script properties as well as detail, footer, groups and header slots.

- The on-start script called before the first row is retrieved from the data set for this element. Called after the data set is open but before the header band is created.
- The on-row script called for each row retrieved from the data set for this element, but before creating any content for that row.
- The on-finish script called after the last row is read from the data set for this element, but before the footer band is created.

See Also:
  - `ListingElement`
  - `SlotHandle`

## Field Summary

### Fields inherited from class org.eclipse.birt.report.model.api.ReportItemHandleImpl

`DATABINDING_TYPE_DATA, DATABINDING_TYPE_NONE, DATABINDING_TYPE_REPORT_ITEM_REF`

### Fields inherited from class org.eclipse.birt.report.model.api.ReportElementHandle

`element`

### Fields inherited from class org.eclipse.birt.report.model.api.DesignElementHandle

`module`

### Fields inherited from interface org.eclipse.birt.report.model.elements.interfaces.IDesignElementModel

`COMMENTS_PROP, CUSTOM_XML_PROP, DISPLAY_NAME_ID_PROP, DISPLAY_NAME_PROP, EVENT_HANDLER_CLASS_PROP, EXTENDS_PROP, FULL_LABEL, ID_SUFFIX, NAME_PROP, NEW_HANDLER_ON_EACH_EVENT_PROP, NO_SLOT, PROPERTY_MASKS_PROP, REF_TEMPLATE_PARAMETER_PROP, SHORT_LABEL, USER_LABEL, USER_PROPERTIES_PROP, VIEW_ACTION_PROP`

### Fields inherited from interface org.eclipse.birt.report.model.elements.interfaces.IInternalReportItemModel

`ACL_EXPRESSION_PROP, ALLOW_EXPORT_PROP, ALTTEXT_KEY_PROP, ALTTEXT_PROP, BOOKMARK_DISPLAY_NAME_PROP, BOOKMARK_PROP, BOUND_DATA_COLUMNS_PROP, CASCADE_ACL_PROP, CUBE_PROP, DATA_BINDING_REF_PROP, DATA_SET_PROP, HEIGHT_PROP, LANGUAGE_PROP, MULTI_VIEWS_PROP, ON_CREATE_METHOD, ON_PAGE_BREAK_METHOD, ON_PREPARE_METHOD, ON_RENDER_METHOD, ORDER_PROP, PARAM_BINDINGS_PROP, PUSH_DOWN_PROP, TAG_TYPE_PROP, THEME_PROP, TOC_PROP, URL_PROP, VISIBILITY_PROP, WIDTH_PROP, X_PROP, Y_PROP, Z_INDEX_PROP`

### Fields inherited from interface org.eclipse.birt.report.model.elements.interfaces.IListingElementModel

`DETAIL_SLOT, FILTER_PROP, FOOTER_SLOT, GROUP_SLOT, HEADER_SLOT, ON_FINISH_METHOD, ON_ROW_METHOD, ON_START_METHOD, PAGE_BREAK_INTERVAL_PROP, REPEAT_HEADER_PROP, SORT_BY_GROUPS_PROP, SORT_PROP`

### Fields inherited from interface org.eclipse.birt.report.model.api.elements.IReportItemMethodContext

`ON_CREATE_CONTEXT, ON_PREPARE_CONTEXT, ON_RENDER_CONTEXT`

### Fields inherited from interface org.eclipse.birt.report.model.elements.interfaces.IStyledElementModel

`STYLE_PROP`

## Constructor Summary

Constructors
Constructor
Description
`ListingHandle(org.eclipse.birt.report.model.core.Module module, org.eclipse.birt.report.model.core.DesignElement element)`
Constructs a listing handle with the given design and the element.

## Method Summary

Modifier and Type
Method
Description
`Iterator<FilterConditionHandle>`
`filtersIterator()`
Returns the iterator for filter list defined on a table or list.
`SlotHandle`
`getDetail()`
Returns the detail slot.
`SlotHandle`
`getFooter()`
Returns the footer slot.
`SlotHandle`
`getGroups()`
Returns the group slot.
`SlotHandle`
`getHeader()`
Returns the header slot.
`int`
`getPageBreakInterval()`
Returns the page break interval value
`boolean`
`isSortByGroups()`
Determines whether the result set of this element will be sorted by the group keys.
`boolean`
`repeatHeader()`
Tests whether to repeat the headings at the top of each page.
`void`
`setPageBreakInterval(int pageBreakInterval)`
Sets the page break interval value
`void`
`setRepeatHeader(boolean value)`
Sets whether to repeat the headings at the top of each page.
`void`
`setSortByGroups(boolean isSortByGroups)`
Sets whether the result set of this element will be sorted by the group keys.
`Iterator`
`sortsIterator()`
Returns the iterator for sort list defined on a table or list.

### Methods inherited from class org.eclipse.birt.report.model.api.ReportItemHandleImpl

`addColumnBinding, addTOC, addTOC, addView, allowExport, canAddView, canCascadeACL, cascadeACL, columnBindingsIterator, dropView, findColumnBinding, getACLExpression, getAltTextExpression, getAltTextKey, getAvailableBindings, getAvailableCubeBindingReferenceList, getAvailableDataBindingReferenceList, getAvailableDataBindingReferenceList, getAvailableDataSetBindingReferenceList, getBookmark, getBookmarkDisplayName, getColumnBindings, getCube, getCurrentView, getDataBindingReference, getDataBindingReferenceName, getDataBindingType, getDataSet, getHeight, getLanguage, getMethods, getNamedCubeBindingReferenceList, getNamedDataBindingReferenceList, getNamedDataSetBindingReferenceList, getOnCreate, getOnPageBreak, getOnPrepare, getOnRender, getOrder, getProperty, getTagType, getTheme, getTOC, getTocExpression, getURL, getViewHost, getViews, getWidth, getX, getY, getZIndex, paramBindingsIterator, pushDown, removedColumnBinding, removedColumnBindings, removedUnusedColumnBindings, setACLExpression, setAllowExport, setAltTextExpression, setAltTextKey, setBookmark, setBookmarkDisplayName, setCascadeACL, setCube, setCurrentView, setDataBindingReference, setDataSet, setHeight, setHeight, setLanguage, setOnCreate, setOnPageBreak, setOnPrepare, setOnRender, setOrder, setPushDown, setTagType, setTheme, setThemeName, setTocExpression, setURL, setWidth, setWidth, setX, setX, setY, setY, setZIndex, visibilityRulesIterator`

### Methods inherited from class org.eclipse.birt.report.model.api.ReportElementHandle

`getComments, getCustomXml, getDisplayName, getDisplayNameKey, getElement, getPropertyMask, isValidLayoutForCompoundElement, isValidReferenceForCompoundElement, propertyMaskIterator, setComments, setCustomXml, setDisplayName, setDisplayNameKey, setPropertyMask`

### Methods inherited from class org.eclipse.birt.report.model.api.DesignElementHandle

`add, add, addElement, addElement, addListener, addUserPropertyDefn, cachePropertyHandles, canContain, canContain, canContain, canContain, canDrop, canEdit, canTransformToTemplate, clearAllProperties, clearContents, clearProperty, clientsIterator, copy, copyPropertyTo, createTemplateElement, derivedIterator, doSort, drop, drop, drop, dropAndClear, dropAndClear, dropAndClear, dropUserPropertyDefn, findContentSlot, getBooleanProperty, getChoices, getColorProperty, getContainer, getContainerPropertyHandle, getContainerSlotHandle, getContent, getContentCount, getContents, getDefn, getDesign, getDesignHandle, getDimensionProperty, getDisplayLabel, getDisplayLabel, getDisplayProperty, getEffectiveModule, getElementFactory, getElementProperty, getEventHandlerClass, getExpressionProperty, getExtends, getExternalizedValue, getExternalizedValue, getExternalizedValue, getFactoryElementHandle, getFactoryPropertyHandle, getFloatProperty, getFontProperty, getFullName, getHostViewHandle, getID, getIndex, getIntProperty, getListProperty, getListProperty, getMethods, getModule, getModuleHandle, getName, getNumberProperty, getPrivateStyle, getPropertyBinding, getPropertyBindingExpression, getPropertyBindings, getPropertyDefn, getPropertyHandle, getPropertyIterator, getQualifiedName, getRoot, getSemanticErrors, getSlot, getStringProperty, getStyle, getUserProperties, getUserPropertyDefnHandle, getXPath, hasLocalProperties, hasSemanticError, initializeSlotHandles, isDirectionRTL, isInTemplateParameter, isTemplateParameterValue, isValid, localize, move, move, moveTo, moveTo, moveTo, moveTo, newHandlerOnEachEvent, paste, paste, paste, paste, removeListener, revertToReportItem, revertToTemplate, semanticCheck, setBooleanProperty, setEncryption, setEventHandlerClass, setExpressionProperty, setExtends, setExtendsElement, setExtendsName, setFloatProperty, setIntProperty, setName, setNewHandlerOnEachEvent, setNumberProperty, setProperties, setProperty, setPropertyBinding, setPropertyBinding, setStringProperty, setStyle, setStyleElement, setStyleName, setValid, shift, showError, slotsIterator`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ListingHandle

public ListingHandle(org.eclipse.birt.report.model.core.Module module, org.eclipse.birt.report.model.core.DesignElement element)
Constructs a listing handle with the given design and the element. The application generally does not create handles directly. Instead, it uses one of the navigation methods available on other element handles.

Parameters:
  `module` - the module
  `element` - the model representation of the element

## Method Details

### getHeader

public SlotHandle getHeader()
Returns the header slot. The header slot represents subsections that print at the start of the listing.

Returns:
  a handle to the header slot

### getFooter

public SlotHandle getFooter()
Returns the footer slot. The footer slot represents subsections that print at the end of the listing.

Returns:
  a handle to the footer slot

### getDetail

public SlotHandle getDetail()
Returns the detail slot. The detail slot represents subsections that print for each row in the data set.

Returns:
  a handle to the detail slot

### getGroups

public SlotHandle getGroups()
Returns the group slot. The group slot represents the grouping levels within the report. Groups appear with the most general first, the most detailed last.

Returns:
  a handle to the group slot

### sortsIterator

public Iterator sortsIterator()
Returns the iterator for sort list defined on a table or list. The element in the iterator is the corresponding `StructureHandle` that deal with a `SortKey` in the list.

Returns:
  the iterator for `SortKey` structure list defined on a table or list.

### filtersIterator

public Iterator<FilterConditionHandle> filtersIterator()
Returns the iterator for filter list defined on a table or list. The element in the iterator is the corresponding `StructureHandle` that deal with a `FilterCond` in the list.

Returns:
  the iterator for `FilterCond` structure list defined on a table or list.

### getPageBreakInterval

public int getPageBreakInterval()
Returns the page break interval value

Returns:
  the page break interval value

### setPageBreakInterval

public void setPageBreakInterval(int pageBreakInterval) throws SemanticException
Sets the page break interval value

Parameters:
  `pageBreakInterval` - the page break interval
Throws:
  `SemanticException` - if the parameter is not a valid integer

### repeatHeader

public boolean repeatHeader()
Tests whether to repeat the headings at the top of each page.

Returns:
  `true` if repeat the headings, otherwise `false`.

### setRepeatHeader

public void setRepeatHeader(boolean value) throws SemanticException
Sets whether to repeat the headings at the top of each page.

Parameters:
  `value` - `true` if repeat the headings, otherwise `false`.
Throws:
  `SemanticException` - if the property is locked.

### isSortByGroups

public boolean isSortByGroups()
Determines whether the result set of this element will be sorted by the group keys.

Returns:
  true if sorted by the groups, otherwise false

### setSortByGroups

public void setSortByGroups(boolean isSortByGroups) throws SemanticException
Sets whether the result set of this element will be sorted by the group keys.

Parameters:
  `isSortByGroups` - true if sorted by the groups, otherwise false
Throws:
  `SemanticException` - if the property is locked